Ns = 10^5; Tb = 1; fc = 2/Tb; fs = 4*fc; N = fs/Tb; 
t = 0:1/fs:Ns*Tb;
d_d = round(rand(1, Ns));
d_I = d_d(1:2:length(d_d)); d_Q = d_d(2:2:length(d_d));
b_I = zeros(1, length(t)); b_Q = zeros(1,length(t));
for i = 1:Ns/2
if d_I(i)
    b_I((1:N)+N*(i-1)) = 1;
end
if d_Q(i)
    b_Q((1:N)+N*(i-1))=1;
end
end
b_I = b_I*2-1; b_Q = b_Q*2-1;
s_I = b_I.*(sqrt(2)/sqrt(Tb)).*sin(2*pi*fc.*t);
s_Q = b_Q.*(sqrt(2)/sqrt(Tb)).*cos(2*pi*fc.*t);
s_t=s_I+s_Q;
subplot(311)
plot(t(1:100), s_I(1:100))
axis([0 12.4 -1.6 1.6]);
title('Modulated PSK signal: In-phase');
subplot(312)
plot(t(1:100), s_Q(1:100))
axis([0 12.4 -1.6 1.6]);
title('Modulated PSK signal: Quadrature');
subplot(313)
plot(t(1:100),s_t(1:100))
axis([0 12.4 -1.6 1.6]);
title('Modulated QPSK signal');




