syms y k t omega eta E0 real
disp('Electric field intensity in phasor domain')
E_phasor = E0*exp(-j*k*y)*[0 0 1];
pretty(E_phasor)
a_y=[0 1 0];
disp('Magnetic field intensity in phasor domain') 
H_phasor = (1/eta)*cross(a_y,E_phasor);
pretty(H_phasor)
disp('Magnetic field intensity in time domain') 
H_time = real(H_phasor*exp(j*omega*t)); 
H_time = simplify(H_time); 
pretty(H_time)



