d_d = round(rand(1, 10^4)); n = length(d_d); Tb = 1;
Nc = 15; fc = 4/Tb*Nc; fs = 4*fc; Ns = fs/Tb; 
t = 0:1/fs:n*Tb; b_t = zeros(1, length(t));
for i = 1:n
if d_d(i)
b_t((1:Ns)+Ns*(i-1)) = 1;
end
end
b_t = b_t * 2 - 1;
pn = round(rand(1, n*Nc)); pn_t = zeros(1, length(t));
for i = 1:n*Nc
if pn(i)
pn_t((1:Ns/Nc)+Ns/Nc*(i-1)) = 1;
end
end
pn_t= pn_t * 2 - 1; spr_t = b_t .* pn_t;
mod_t = spr_t .* (sqrt(2)/sqrt(Tb)).* sin(2*pi*fc.*t);
subplot(311);
plot(t(1:10*Ns), b_t(1:10*Ns))
axis([t(1), t(10*Ns), -1.5,1.5])
title('Baseband signal');
subplot(312);
plot(t(1:10*Ns), pn_t(1:10*Ns))
axis([t(1), t(10*Ns), -1.5,1.5])
title('Pseudo-noise sequence signal');
subplot(313);
plot(t(1:10*Ns), spr_t(1:10*Ns))
axis([t(1), t(10*Ns), -1.5,1.5])
xlabel('Time');
title('Modulated spread-spectrum signal');





